Subject: Re: [ietf-types] Request for review of standards tree registration request for OpenXPS
From: Brian Clubb <[email-masked]>
To: Paul Libbrecht <[email-masked]>
Cc: "[email-masked]" <[email-masked]>
Date: Tue, 15 Feb 2011 18:08:40 +0000
List-Id: "Media \(MIME\) type review" <ietf-types.ietf.org>

Paul,

Thanks again for the feedback.  I am making the changes to the template.  I am including, then, the final template in this reply.  If there are no other issues, then I will submit it for acceptance by the end of this week.

Thanks for all your help!  It is much appreciated!

Brian

<template>
Name : Brian Clubb

Email : [email-masked]

MIME media type name : application

MIME subtype name : Standards Tree - openxps

Required parameters : N/A

Optional parameters :
N/A

Encoding considerations : 8-bit

Security considerations :
OpenXPS uses ZIP compression as specified in .ZIP File Format Specification from PKWARE, Inc., version 6.2.0 (2004).  ZIP compressed XML requires parsing untrusted XML data and untrusted ZIP data.  consumer is responsible for validating the .zip archive, the XML structure, and the resource content.  Per spec, there should be no active content provided as part of the OpenXPS format.  The consumer must ensure that no malicious active content is erroneously provided in the OpenXPS document.  Valid content is described in the EMCA-388 specification (http://www.ecma-international.org/publications/standards/Ecma-388.htm)

Also see section E.3 of ECMA-388 specification (http://www.ecma-international.org/publications/standards/Ecma-388.htm)

OpenXPS Documents follow requirements set out in this Standard, as well as other normative references including the Open Packaging Conventions. Implementations may use the following steps to identify an unknown file or stream as an OpenXPS Document within an Open Packaging Conventions payload. 1. Test that the file or stream is a ZIP file a. As required by §9.2 of the Open Packaging Conventions  

b. First four bytes correspond to the local file header signature defined in the .ZIP File Format Specification from PKWARE, Inc., version 6.2.0 (2004)  2. Test that a valid Package Relationships zip item exists a. As required by §8.3.4 of the Open Packaging Conventions b. Check that the content type for the package relationships zip item is correctly defined in the Content Types stream (see OPC §8.1.2) as a relationships part 3. Test that the Package Relationships Part contains a relationship (see OPC §8.3) whose Target attribute points to a valid FixedDocumentSequence Part a. As required by §10.2 of this Standard b. Check that the content type for the FixedDocumentSequence part is correctly defined in the Content Types stream as a FixedDocumentSequence part 

Interoperability considerations :
application/OpenXPS documents are specified by the XML schemas
   standardized in ECMA-388.
Applications and drivers currently producing/consuming Microsoft XPS content cannot directly produce/consume OpenXPS.  Changes are required to address differences in the two specifications, such as namespace, print ticket usage, use of JPEG XR, etc.

Published specification :
The published Standard ECMA-388 is available at:
http://www.ecma-international.org/publications/standards/Ecma-388.htm

Applications which use this media :
The application/oxps MIME type can be used to identify CSTA XML
(ECMA-388) instance documents.  No published applications or print drivers currently use OpenXPS.  The intent is for any application or driver that can currently produce/consume Microsoft XPS to also adopt OpenXPS.  Examples of such applications would include but are not limited to:  Microsoft XPS Viewer, Microsoft XPS Document Writer, Microsoft Internet Explorer 9.

Additional information :

1. Magic number(s) : ZIP archive CRC-32: 0xdebb20e3 per http://www.pkware.com/documents/APPNOTE/APPNOTE-6.2.0.txt
2. File extension(s) : .oxps
3. Macintosh file type code : org.ecma.oxps conforms to com.pkware.zip-archive
4. Object Identifiers: N/A
5. Windows clipboard name:  "OpenXPS"

To ensure interoperability, the clipboard format must be a complete OpenXPS file with .oxps extension.

Person & email address to contact for further information:
Ecma International Helpdesk
Rue du Rhone114
CH-1204 Geneva
Switzerland
[email-masked]

Person to contact for further information :

1. Name : Ecma International Helpdesk
2. Email : [email-masked]

Intended usage : Common
This type will be used for all documents conforming to the Open XML
   Paper Specifcation's (ECMA-388) Open XPS Document format, published
   by ECMA.
</template>

-----Original Message-----
From: Paul Libbrecht [mailto:[email-masked]] 
Sent: Tuesday, February 01, 2011 10:45 AM
To: Brian Clubb
Cc: [email-masked]
Subject: Re: [ietf-types] Request for review of standards tree registration request for OpenXPS

Brian,

my suggestion was to add something similar to the following in the Additional Information section:

    Macintosh Universal Type Identifier code:
        org.ecma.xps conforms to com.pkware.zip-archive
    Windows Clipboard Name:
        "OpenXPS"

This allows putting or expecting OpenXPS in the clipboard or a drag-and-drop, when this comes, to safely put and select by name.

I do not think that stating that it must be a complete OpenXPS file nor anything wrt its name is useful. 
(the first is natural, the second is not applicable since clipboards don't have filenames that are visible).

paul

Le 1 févr. 2011 à 19:27, Brian Clubb a écrit :

> Thanks, Paul!  I appreciate the detailed feedback!
> 
> I propose to add the following to the "Additional Information" section of the template:
> 
> "To ensure interoperability, the clipboard format must be a complete OpenXPS file with .oxps extension."
> 
> Thanks!
> Brian
> 
> 
> -----Original Message-----
> From: Paul Libbrecht [mailto:[email-masked]] 
> Sent: Monday, January 31, 2011 12:58 PM
> To: Brian Clubb
> Cc: [email-masked]
> Subject: Re: [ietf-types] Request for review of standards tree registration request for OpenXPS
> 
> Hello Brian, 
> 
> Le 31 janv. 2011 à 19:33, Brian Clubb a écrit :
>> While the OpenXPS package contains XML, the document itself requires the hierarchical tree structure of pages and resources to be functional.  It is intended that only a complete OpenXPS document would ever be posted to the clipboard.  
> 
> Sure. Only well formed data here (and well formedness is more than XML's).
> 
>> Posting a fragment of an OpenXPS file to the clipboard would not be a useful scenario in the same way that I understand it would work in MathML or SVG.  The resource tree in OpenXPS is integral to its functionality.
> 
> But that is clear.
> It doesn't remove the usefulness of such a thing.
> 
> As I said, PDF is the preferred flavor for vector graphics on MacOSX.
> And rest assured that copying from a page of a 200 pages book with Apple Preview does not create a PDF with  many pages when copying a rectangle.
> 
> Earlier examples on the mac of such transfers include the PICT format and the Adobe "AIFB" (?? I think ??) format which was taken huge time to be produced when you had just copied something, say, in PhotoShop and was switching away from it (in MaOS 7-9, I suppose the same must have been done on Windows).
> 
>> For example, copying the XML for a fixed page out of one file onto the clipboard would not take into account the image and font resources which are stored in other locations in the OpenXPS file.  
> 
> That's the duty of the clipboard exporter. A normal composition programme can do that but viewers may have difficulties "at first", this is true.
> 
> In the very same fashion copying html in a browser also inlines all the styles (even coming from very far from this element) when going out to, say, an email or word-processing application (in html or rtf).
> 
>> Furthermore, re-integrating that page markup into the structure of another OpenXPS file would be extraordinarily complex.  If one were to wish to copy pages from one OpenXPS file to another, they would need to create a complete OpenXPS package containing just the required pages plus the required resources from the original OpenXPS package then post the new OpenXPS file to the clipboard.  The consuming application would then be able to access that file and its resources reliably and logically insert the pages and resources into their OpenXPS document package as needed.
> 
> I'm sure this can be and has been already done.
> 
>> If an application such as an XPS Viewer were to allow selecting and copying of the text or image elements displayed on the screen, that data would be placed on the clipboard as text or whatever image format the application chooses to provide,
> 
> right.
> And one day that format might be openXPS.
> 
>> but posting the markup for the selection to the clipboard would not provide the relevant resource data and hierarchy and would thus be unusable as OpenXPS at that point.
> 
> no markup only copy.
> 
>> I believe, then, that it is correct to say that the clipboard format would always be a complete OpenXPS file with .oxps extension.  It is the only format for the clipboard that would provide the required interoperability between OpenXPS-consuming applications.
> 
> I think this is correct.
> 
> paul

From: Bjoern Hoehrmann <[email-masked]>
To: MURATA Makoto <[email-masked]>
Date: Thu, 03 Feb 2011 01:21:56 +0100
Cc: [email-masked], Nick Bogaty <[email-masked]>, 'John Rivlin' <[email-masked]>, 'Ric Wright' <[email-masked]>, 'Garth Conboy' <[email-masked]>
Subject: Re: [ietf-types] Mime Type Reg for "application/epub+zip"

* MURATA Makoto wrote:
>For EPUB to be a good citizen of Internet, I think that registration 
>of application/epub+zip is a necessary step.  I am wondering how we 
>should go forward.  Here are some possibilities I can think of.
>
>1) Create an IDPF EPUB3 spec,  describe everything about this media 
>type (including possible frag. identifiers), and request for the
>approval of IESG.
>
>2) Create an ISO or IEC or JTC1 EPUB specification (possible EPUB2),
>describe everything there, and request for the approval of IESG.
>
>3) Begin with an I-D and describe everything there and try to reach 
> (proposed standard?) RFC status, and register the media type.

Well, as far as ietf-types review is concerned, if a type is actually
used, then it should be registered, the registration should not clash
with conflicting usage (like, if the type in question is also used for
something else) and the registration information should meet the re-
quirements of RFC 4288 and dependencies. From that perspective, the
options above seem relatively equal. Your third option seems to have
the best chances to produce results quickly though.
-- 
Björn Höhrmann · mailto:[email-masked] · http://bjoern.hoehrmann.de
Am Badedeich 7 · Telefon: +49(0)160/4415681 · http://www.bjoernsworld.de
25899 Dagebüll · PGP Pub. KeyID: 0xA4357E78 · http://www.websitedev.de/ 

Date: Thu, 03 Feb 2011 08:43:22 +0900
From: MURATA Makoto <[email-masked]>
To: <[email-masked]>
Cc: 'Ric Wright' <[email-masked]>, Nick Bogaty <[email-masked]>, 'John Rivlin' <[email-masked]>, 'Garth Conboy' <[email-masked]>
Subject: Re: [ietf-types] Mime Type Reg for "application/epub+zip"

Dear colleagues,

In 2007, IDPF (http://www.idpf.org/) submitted a request to register a
standard-tree media type "application/epub+zip" for EPUB documents. 
There were no discussions or registrations, however.  The I-D 
at that time, namely http://www.idpf.org/draft-idpf-mime-ocf-01.txt, has
already expired.

Since then, things have changed.  EPUB has become a very important 
e-book format, and is very widely used by Apple, Adobe, Sony, Barns & Noble, 
among others.  EPUB implementations appear to use "application/epub+zip".
The IDPF EPUB WG is actively designing the next version of EPUB, namely
EPUB3, and has committed to finish it in May, 2011.

Standardization of EPUB at ISO, IEC, or JTC1 is also being discussed 
at ISO/IEC JTC1/SC34/AHG4 (EPUB).    IDPF is involved.

Moreover, the EPUB WG of IDPF is currently talking about introducing
fragment identifiers for EPUB3.   A proposal is available at
http://code.google.com/p/epub-revision/wiki/ImplementationProposalFragmentIdentifier

For EPUB to be a good citizen of Internet, I think that registration 
of application/epub+zip is a necessary step.  I am wondering how we 
should go forward.  Here are some possibilities I can think of.

1) Create an IDPF EPUB3 spec,  describe everything about this media 
type (including possible frag. identifiers), and request for the
approval of IESG.

2) Create an ISO or IEC or JTC1 EPUB specification (possible EPUB2),
describe everything there, and request for the approval of IESG.

3) Begin with an I-D and describe everything there and try to reach 
 (proposed standard?) RFC status, and register the media type.

How do people feel?

Cheers,
-- 
MURATA Makoto <[email-masked]>

From: Paul Libbrecht <[email-masked]>
Date: Tue, 1 Feb 2011 19:45:09 +0100
To: Brian Clubb <[email-masked]>
Cc: "[email-masked]" <[email-masked]>
Subject: Re: [ietf-types] Request for review of standards tree registration request for OpenXPS

Brian,

my suggestion was to add something similar to the following in the Additional Information section:

    Macintosh Universal Type Identifier code:
        org.ecma.xps conforms to com.pkware.zip-archive
    Windows Clipboard Name:
        "OpenXPS"

This allows putting or expecting OpenXPS in the clipboard or a drag-and-drop, when this comes, to safely put and select by name.

I do not think that stating that it must be a complete OpenXPS file nor anything wrt its name is useful. 
(the first is natural, the second is not applicable since clipboards don't have filenames that are visible).

paul

Le 1 févr. 2011 à 19:27, Brian Clubb a écrit :

> Thanks, Paul!  I appreciate the detailed feedback!
> 
> I propose to add the following to the "Additional Information" section of the template:
> 
> "To ensure interoperability, the clipboard format must be a complete OpenXPS file with .oxps extension."
> 
> Thanks!
> Brian
> 
> 
> -----Original Message-----
> From: Paul Libbrecht [mailto:[email-masked]] 
> Sent: Monday, January 31, 2011 12:58 PM
> To: Brian Clubb
> Cc: [email-masked]
> Subject: Re: [ietf-types] Request for review of standards tree registration request for OpenXPS
> 
> Hello Brian, 
> 
> Le 31 janv. 2011 à 19:33, Brian Clubb a écrit :
>> While the OpenXPS package contains XML, the document itself requires the hierarchical tree structure of pages and resources to be functional.  It is intended that only a complete OpenXPS document would ever be posted to the clipboard.  
> 
> Sure. Only well formed data here (and well formedness is more than XML's).
> 
>> Posting a fragment of an OpenXPS file to the clipboard would not be a useful scenario in the same way that I understand it would work in MathML or SVG.  The resource tree in OpenXPS is integral to its functionality.
> 
> But that is clear.
> It doesn't remove the usefulness of such a thing.
> 
> As I said, PDF is the preferred flavor for vector graphics on MacOSX.
> And rest assured that copying from a page of a 200 pages book with Apple Preview does not create a PDF with  many pages when copying a rectangle.
> 
> Earlier examples on the mac of such transfers include the PICT format and the Adobe "AIFB" (?? I think ??) format which was taken huge time to be produced when you had just copied something, say, in PhotoShop and was switching away from it (in MaOS 7-9, I suppose the same must have been done on Windows).
> 
>> For example, copying the XML for a fixed page out of one file onto the clipboard would not take into account the image and font resources which are stored in other locations in the OpenXPS file.  
> 
> That's the duty of the clipboard exporter. A normal composition programme can do that but viewers may have difficulties "at first", this is true.
> 
> In the very same fashion copying html in a browser also inlines all the styles (even coming from very far from this element) when going out to, say, an email or word-processing application (in html or rtf).
> 
>> Furthermore, re-integrating that page markup into the structure of another OpenXPS file would be extraordinarily complex.  If one were to wish to copy pages from one OpenXPS file to another, they would need to create a complete OpenXPS package containing just the required pages plus the required resources from the original OpenXPS package then post the new OpenXPS file to the clipboard.  The consuming application would then be able to access that file and its resources reliably and logically insert the pages and resources into their OpenXPS document package as needed.
> 
> I'm sure this can be and has been already done.
> 
>> If an application such as an XPS Viewer were to allow selecting and copying of the text or image elements displayed on the screen, that data would be placed on the clipboard as text or whatever image format the application chooses to provide,
> 
> right.
> And one day that format might be openXPS.
> 
>> but posting the markup for the selection to the clipboard would not provide the relevant resource data and hierarchy and would thus be unusable as OpenXPS at that point.
> 
> no markup only copy.
> 
>> I believe, then, that it is correct to say that the clipboard format would always be a complete OpenXPS file with .oxps extension.  It is the only format for the clipboard that would provide the required interoperability between OpenXPS-consuming applications.
> 
> I think this is correct.
> 
> paul

From: Brian Clubb <[email-masked]>
To: Paul Libbrecht <[email-masked]>
Accept-Language: en-US
Cc: "[email-masked]" <[email-masked]>
Subject: Re: [ietf-types] Request for review of standards tree registration request for OpenXPS

Thanks, Paul!  I appreciate the detailed feedback!

I propose to add the following to the "Additional Information" section of the template:

"To ensure interoperability, the clipboard format must be a complete OpenXPS file with .oxps extension."

Thanks!
Brian

-----Original Message-----
From: Paul Libbrecht [mailto:[email-masked]] 
Sent: Monday, January 31, 2011 12:58 PM
To: Brian Clubb
Cc: [email-masked]
Subject: Re: [ietf-types] Request for review of standards tree registration request for OpenXPS

Hello Brian, 

Le 31 janv. 2011 à 19:33, Brian Clubb a écrit :
> While the OpenXPS package contains XML, the document itself requires the hierarchical tree structure of pages and resources to be functional.  It is intended that only a complete OpenXPS document would ever be posted to the clipboard.  

Sure. Only well formed data here (and well formedness is more than XML's).

> Posting a fragment of an OpenXPS file to the clipboard would not be a useful scenario in the same way that I understand it would work in MathML or SVG.  The resource tree in OpenXPS is integral to its functionality.

But that is clear.
It doesn't remove the usefulness of such a thing.

As I said, PDF is the preferred flavor for vector graphics on MacOSX.
And rest assured that copying from a page of a 200 pages book with Apple Preview does not create a PDF with  many pages when copying a rectangle.

Earlier examples on the mac of such transfers include the PICT format and the Adobe "AIFB" (?? I think ??) format which was taken huge time to be produced when you had just copied something, say, in PhotoShop and was switching away from it (in MaOS 7-9, I suppose the same must have been done on Windows).

> For example, copying the XML for a fixed page out of one file onto the clipboard would not take into account the image and font resources which are stored in other locations in the OpenXPS file.  

That's the duty of the clipboard exporter. A normal composition programme can do that but viewers may have difficulties "at first", this is true.

In the very same fashion copying html in a browser also inlines all the styles (even coming from very far from this element) when going out to, say, an email or word-processing application (in html or rtf).

> Furthermore, re-integrating that page markup into the structure of another OpenXPS file would be extraordinarily complex.  If one were to wish to copy pages from one OpenXPS file to another, they would need to create a complete OpenXPS package containing just the required pages plus the required resources from the original OpenXPS package then post the new OpenXPS file to the clipboard.  The consuming application would then be able to access that file and its resources reliably and logically insert the pages and resources into their OpenXPS document package as needed.

I'm sure this can be and has been already done.

> If an application such as an XPS Viewer were to allow selecting and copying of the text or image elements displayed on the screen, that data would be placed on the clipboard as text or whatever image format the application chooses to provide,

right.
And one day that format might be openXPS.

> but posting the markup for the selection to the clipboard would not provide the relevant resource data and hierarchy and would thus be unusable as OpenXPS at that point.

no markup only copy.

> I believe, then, that it is correct to say that the clipboard format would always be a complete OpenXPS file with .oxps extension.  It is the only format for the clipboard that would provide the required interoperability between OpenXPS-consuming applications.

I think this is correct.

paul